#include-once
#include <AutoItConstants.au3>; $EXITCLOSE_BYSHUTDOWN

Global Enum  $AUERLO_LVL_ALL;        $AUERLO_LVL_TRACE synonym.
Global Enum  $AUERLO_LVL_TRACE, _;   Proof of execution. Progression monitoring. Execution time monitoring. Script start and exit. New code. Default (lowest importance).
			 $AUERLO_LVL_DEBUG, _;   Initializations (and anything else taken for granted), anything of contextual value (@extended, etc.), UDF's internally, assertions, edge-case detection, new code.
			 $AUERLO_LVL_INFO, _;    User messages and regular ConsoleWrite()'s. Global state or -context changes.
			 $AUERLO_LVL_WARNING, _; Anything unexpected or unusual. Failed assertions, triggered singleton check, fall back to default setting (due to missing file for example), etc.
			 $AUERLO_LVL_ERROR, _;   Regular errors.
			 $AUERLO_LVL_FATAL, _;   Fatal errors and non-zero @exitCode.
			 $AUERLO_LVL__ENUM
Global Enum  $AUERLO_OPT_FILEPATH, _;     str - error log file path
			 $AUERLO_OPT_FILEDELMCOL, _;  str - error log file col delimiter
			 $AUERLO_OPT_FILEDELMROW, _;  str - error log file row delimiter
			 $AUERLO_OPT_FILEENC, _;      int - error log file encoding ($FO_UTF8_NOBOM by default)
			 $AUERLO_OPT_LVLFILE, _;      int - log level threshold for error log ($AUERLO_LVL__ENUM or $AUERLO_LVL_ALL, $AUERLO_LVL_WARNING by default)
			 $AUERLO_OPT_LVLSTD, _;       int - log level threshold for console   ($AUERLO_LVL__ENUM or $AUERLO_LVL_ALL, $AUERLO_LVL_INFO    by default)
			 $AUERLO_OPT_LVLALERT, _;     int - log level threshold for alert     ($AUERLO_LVL__ENUM or $AUERLO_LVL_ALL, $AUERLO_LVL_ERROR   by default)
			 $AUERLO_OPT_LVLNOTIFY, _;    int - log level threshold for prompt    ($AUERLO_LVL__ENUM or $AUERLO_LVL_ALL, $AUERLO_LVL_ERROR   by default)
			 $AUERLO_OPT_LVLCUSTOM, _;    int - log level threshold for custom    ($AUERLO_LVL__ENUM or $AUERLO_LVL_ALL, $AUERLO_LVL_ALL     by default)
			 $AUERLO_OPT_ACTIVE, _;       bln - output global toggle (off if false)
			 $AUERLO_OPT_TIMEUTC, _;      bln - output time UTC (local time if false)
			 $AUERLO_OPT_LOGFILE, _;      bln - output to file
			 $AUERLO_OPT_LOGSTD, _;       bln - output to stdout/stderr
			 $AUERLO_OPT_LOGALERT, _;     bln - output to alert
			 $AUERLO_OPT_LOGNOTIFY, _;    bln - output to prompt (dialog)
			 $AUERLO_OPT_LOGCUSTOM, _;    bln - output to custom function
			 $AUERLO_OPT_FUNCTIME, _;     fnc - (fnc/Default)      function to return current date/time str
			 $AUERLO_OPT_FUNCEXIT, _;     fnc - (fnc/Default/Null) function to handle exit logging (not activated on crash)
			 $AUERLO_OPT_FUNCCOM, _;      fnc - (fnc/Default/Null) function to handle COM Object error logging
			 $AUERLO_OPT_FUNCFILE, _;     fnc - (fnc/Default)      function to handle output to file
			 $AUERLO_OPT_FUNCSTD, _;      fnc - (fnc/Default)      function to handle output to std
			 $AUERLO_OPT_FUNCALERT, _;    fnc - (fnc/Default)      function to handle output to alert
			 $AUERLO_OPT_FUNCNOTIFY, _;   fnc - (fnc/Default)      function to handle output to prompt (dialog)
			 $AUERLO_OPT_FUNCCUSTOM, _;   fnc - (fnc/Default/Null) function to handle output to custom purpose
			 $AUERLO_OPT__ENUM
Global Enum  $AUERLO_RET_ERR, _; int - negative return OR error
			 $AUERLO_RET_OK, _;  int - positive return AND no error
			 $AUERLO_RET__ENUM
Global Enum  $AUERLO_ERR_OK, _;         not an error (success)
			 $AUERLO_ERR_ENUM, _;       invalid parameter (out of bound, internal)
			 $AUERLO_ERR_ARRAY, _;      invalid array
			 $AUERLO_ERR_OPT, _;        invalid option
			 $AUERLO_ERR_DATA, _;       invalid setting
			 $AUERLO_ERR_LVL, _;        invalid level
			 $AUERLO_ERR_ATR, _;        invalid attr
			 $AUERLO_ERR_EXC, _;        invalid @exitCode
			 $AUERLO_ERR_ERR, _;        invalid @error
			 $AUERLO_ERR_EXT, _;        invalid @extended
			 $AUERLO_ERR_SLN, _;        invalid @ScriptLineNumber
			 $AUERLO_ERR_DATETIME, _;   invalid date/time format
			 $AUERLO_ERR_FUNCDEF, _;    invalid function definition
			 $AUERLO_ERR_FUNCRET, _;    invalid function return data (or @error)
			 $AUERLO_ERR_FUNCREG, _;    failed to register function
			 $AUERLO_ERR_FUNCUNR, _;    failed to unregister function
			 $AUERLO_ERR_CONVERT, _;    failed to convert date/time to UTC
			 $AUERLO_ERR_FILEEXIST, _;  failed to locate file (invalid file path)
			 $AUERLO_ERR_FILEDELETE, _; failed to delete file
			 $AUERLO_ERR_FILEOPEN, _;   failed to obtain file handle
			 $AUERLO_ERR_FILEREAD, _;   failed to read from file
			 $AUERLO_ERR_FILEWRITE, _;  failed to write to file
			 $AUERLO_ERR__ENUM
Global Enum  $AUERLO_ATR_DATETIME, _; str - YYYY/MM/DD HH:MM:SS by default (Date.au3 -compatible)
			 $AUERLO_ATR_LEVEL, _;    int - $AUERLO_LVL__ENUM
			 $AUERLO_ATR_LINE, _;     int - @ScriptLineNumber (0 if from callback, -1 if @compiled)/$oError.scriptline (-1 if @compiled)
			 $AUERLO_ATR_ERROR, _;    int - @error/@exitCode/$oError.number/_WinAPI_GetLastError()
			 $AUERLO_ATR_EXTENDED, _; int - @extended/@exitMethod/$oError.retcode
			 $AUERLO_ATR_MESSAGE, _;  str - $sMessage
			 $AUERLO_ATR__ENUM
Global Const $AUERLO_MTD__ENUM = $EXITCLOSE_BYSHUTDOWN + 1
